import 'package:domain/entity/response/device_list_entity.dart';
import 'package:domain/repository/other_repository.dart';
import 'package:get/get.dart';
import 'package:plugin_platform/engine/toast/toast_engine.dart';
import 'package:plugin_platform/http/dio/dio_cancelable_mixin.dart';
import 'package:widgets/load_state_layout.dart';
import 'package:widgets/picker/option_pick_util.dart';
import 'package:widgets/widget_export.dart';

import 'device_list_state.dart';

class DeviceListController extends GetxController with DioCancelableMixin {
  final OtherRepository _otherRepository = Get.find();
  final DeviceListState state = DeviceListState();

  var _curPage = 1;
  var _needShowPlaceholder = true;

  //页面PlaceHolder的展示
  LoadState loadingState = LoadState.State_Success;
  String? errorMessage;

  //刷新页面状态
  void changeLoadingState(LoadState state) {
    loadingState = state;
    update();
  }

  // Refresh 控制器
  final EasyRefreshController refreshController = EasyRefreshController(
    controlFinishRefresh: true,
    controlFinishLoad: true,
  );

  // Refresh 刷新事件
  Future onRefresh() async {
    _curPage = 1;
    fetchDeviceList();
  }

  // Refresh 加载事件
  Future loadMore() async {
    _curPage++;
    fetchDeviceList();
  }

  // 重试请求
  Future retryRequest() async {
    _curPage = 1;
    _needShowPlaceholder = true;
    fetchDeviceList();
  }

  /// 获取服务器数据，通知消息列表
  Future fetchDeviceList() async {
    if (_needShowPlaceholder) {
      changeLoadingState(LoadState.State_Loading);
    }

    // 获取 Applied 列表
    var listResult = await _otherRepository.fetchDeviceList(
      curPage: _curPage,
      deviceName: state.keyword,
      isOnline: state.selectedOnlineStatusId,
      cancelToken: cancelToken,
    );

    // 处理数据
    if (listResult.isSuccess) {
      handleList(listResult.data?.rows);
    } else {
      errorMessage = listResult.errorMsg;
      changeLoadingState(LoadState.State_Error);
    }

    // 最后赋值
    _needShowPlaceholder = false;
  }

  // 处理数据与展示的逻辑
  void handleList(List<DeviceListRows>? list) {
    if (list != null && list.isNotEmpty) {
      //有数据，判断是刷新还是加载更多的数据
      if (_curPage == 1) {
        //刷新的方式
        state.datas.clear();
        state.datas.addAll(list);
        refreshController.finishRefresh();

        //更新展示的状态
        changeLoadingState(LoadState.State_Success);
      } else {
        //加载更多
        state.datas.addAll(list);
        refreshController.finishLoad();
        update();
      }
    } else {
      if (_curPage == 1) {
        //展示无数据的布局
        state.datas.clear();
        changeLoadingState(LoadState.State_Empty);
        refreshController.finishRefresh();
      } else {
        //展示加载完成，没有更多数据了
        refreshController.finishLoad(IndicatorResult.noMore);
      }
    }
  }

  @override
  void onReady() {
    super.onReady();
    fetchDeviceList();
  }

  @override
  void onClose() {
    state.datas.clear();
    super.onClose();
  }

  /// 执行搜索
  void doSearch() {
    String? deviceName = state.searchController.text;
    state.keyword = deviceName;
    refreshController.callRefresh();
  }

  /// Pick 在线状态
  void pickOnLineStatus() {
    int selectedStatusIndex;
    if (state.selectedOnlineStatusId == null) {
      selectedStatusIndex = 0;
    } else {
      selectedStatusIndex = state.onlineStatusList.indexWhere((entity) => entity.id == state.selectedOnlineStatusId);
    }

    if (selectedStatusIndex < 0) {
      selectedStatusIndex = 0;
    }

    OptionPickerUtil.showCupertinoOptionPicker(
      items: state.onlineStatusList.map((e) => e.name!).toList(growable: false),
      initialSelectIndex: selectedStatusIndex,
      onPickerChanged: (_, index) {
        state.selectedOnlineStatusId = state.onlineStatusList[index].id;
        state.selectedOnlineStatusName = state.onlineStatusList[index].name;
        update();
        refreshController.callRefresh();
      },
    );
  }
}
